
# cardioidBeam.py
# Andrew Davison, ad@coe.psu.ac.th, Feb. 2025
# https://en.wikipedia.org/wiki/Cardioid
# https://www.youtube.com/watch?v=z3hnh3TzHY8
'''
Replace wheel in cardioid.py with beams.
'''

import math
import os
os.environ['PYGAME_HIDE_SUPPORT_PROMPT'] = "hide"
from pymunk.vec2d import Vec2d
from linkUtils import *

screen = scrInit("Cardioid with Beams")
scrWidth, scrHeight = screen.get_size()
space = pymunk.Space()

coord0 = Vec2d(scrWidth/2, scrHeight/2)
a = 70
coordA = coord0 + Vec2d(-a, 0)
coordB = coord0 + Vec2d(-3*a, 0)
coordC = coord0 + Vec2d(a, 0)
coordD = coord0 + Vec2d(a, 0)

pt0 = staticBall(space, "0", coord0)
ptD = staticBall(space, "D", coordD)
ballA = ball(space, "A", coordA)
ballB = ball(space, "B", coordB, color=RED)
ballC = ball(space, "C", coordC)
sliderE = ball(space, "", coordC)

beam0A = beam(space, pt0, ballA)
beamBC = beam(space, ballB, ballC)

pin(space, beamBC, ballA, (coordC-coordB)/2)

groove(space, beamBC, sliderE)
pin(space, ptD, sliderE)

ballA.velocity=(0,-500)  # move up

animate(screen, space, ballB)
