
# chebLambda.py
# Andrew Davison, ad@coe.psu.ac.th, Feb. 2025
# https://en.wikipedia.org/wiki/Chebyshev_lambda_linkage
# also see chebyshev.py
# this code is the basis of plantigrade.py

import os
os.environ['PYGAME_HIDE_SUPPORT_PROMPT'] = "hide"
from pymunk.vec2d import Vec2d
from linkUtils import *

screen = scrInit("Chebyshev Lambda Linkage")
scrWidth, scrHeight = screen.get_size()
space = pymunk.Space()
coord0 = Vec2d(scrWidth/2, scrHeight/2)

a = 50
coordA = coord0 + Vec2d(-2*a, 0)  
coordB = coord0 + Vec2d(a, 0) 
coordC = coord0 + Vec2d(-0.5*a, -2*a)
coordD = coord0 + Vec2d(-2*a, -4*a)
coordE = coordD + Vec2d(0, a)

pt0 = staticBall(space, "0", coord0)
ptA = staticBall(space, "A", coordA)
ballB = ball(space, "B", coordB)
ballC = ball(space, "C", coordC)  
ballD = ball(space, "D", coordD, color=RED)  

beam0B = beam(space, pt0, ballB)
beamAC = beam(space, ptA, ballC)
beamBD = beam(space, ballB, ballD, color=MUSTARD)
pin(space, beamBD, ballC, (coordD-coordB)/2)

ballB.velocity = (0,200)  # move down
animate(screen, space, ballD)
