
# contraPar.py
# Andrew Davison, ad@coe.psu.ac.th, Feb. 2025
# "Geometric Folding Algorithms", sec 3.2.2.2, p.37
# see braced version in contraParBraced.py

import os
os.environ['PYGAME_HIDE_SUPPORT_PROMPT'] = "hide"
from pymunk.vec2d import Vec2d
from linkUtils import *


screen = scrInit("Contra-Parallelogram", width=900)
scrWidth, scrHeight = screen.get_size()
space = pymunk.Space()
coord0 = Vec2d(scrWidth/2, scrHeight*3/4)

a = 30
coordA = coord0 + Vec2d(-8*a, -4*a)
coordB = coord0 + Vec2d(2*a, -8*a)
coordC = coord0 + Vec2d(8*a, -4*a)
coordD = coord0 + Vec2d(-2*a, -8*a)

ptA = staticBall(space, "A", coordA)
ptB = staticBall(space, "B", coordB)  
ballC = ball(space, "C", coordC)
ballD = ball(space, "D", coordD, color=RED)  

beamAB = beam(space, ptA, ptB)
beamAD = beam(space, ptA, ballD)
beamCD = beam(space, ballC, ballD)
beamCB = beam(space, ballC, ptB)

animate(screen, space, ballD)
