
# crankRocker.py
# Andrew Davison, ad@coe.psu.ac.th, Feb. 2025
# https://en.wikipedia.org/wiki/Four-bar_linkage
# https://www.youtube.com/watch?v=hrvIBtrDNV0
# a planar quadrilateral linkage
# s + l < p + q

import math 
import os
os.environ['PYGAME_HIDE_SUPPORT_PROMPT'] = "hide"
from pymunk.vec2d import Vec2d
from linkUtils import *

screen = scrInit("Crank Rocker Linkage")
scrWidth, scrHeight = screen.get_size()
space = pymunk.Space()

coord0 = Vec2d(scrWidth/2, scrHeight/2)
coordA = coord0 + Vec2d(240, 0)   # q = 240
coordB = coordA + Vec2d(0, -200)  # p = 200
coordC = coord0 + Vec2d(0, -80)   # s = 80

pt0 = staticBall(space, "0", coord0)
ptA = staticBall(space, "A", coordA)
ballB = ball(space, "B", coordB)
ballC = ball(space, "C", coordC)

beam0C = beam(space, pt0, ballC)
beamCB = beam(space, ballC, ballB) 
print("BtoC:", dist(ballC,ballB))   # l = 268
beamAB = beam(space, ptA, ballB)

ballC.velocity = (-500, 0)   # move left
animate(screen, space, ballB)
