
# ellipseBS.py
# Andrew Davison, ad@coe.psu.ac.th, Feb. 2025
# https://www.sineofthetimes.org/a-quartet-of-ellipse-constructions/
# messy initial curve

import os
os.environ['PYGAME_HIDE_SUPPORT_PROMPT'] = "hide"
import pygame
from pymunk.vec2d import Vec2d
from linkUtils import *

title = "Ellipse (Bent Straw)"
screen = scrInit(title)
scrWidth, scrHeight = screen.get_size()
space = pymunk.Space()

coord0 = Vec2d(scrWidth/2, scrHeight/2)

coordA = coord0
coordB = coord0 + Vec2d(120,0)
coordC = coord0 + Vec2d(240,0)
coordD = coord0 - Vec2d(300,0)
coordF = coord0 + Vec2d(300,0)
coordP = coordB + Vec2d(40, 0)

ptD = staticBall(space, "D", coordD)
ptF = staticBall(space, "F", coordF)
ballA = ball(space, "A", coordA)
ballB = ball(space, "B", coordB)
ballC = ball(space, "C", coordC)
ballP = ball(space, "P", coordP, color=RED)

beamDF = beam(space, ptD, ptF)
beamAB = beam(space, ballA, ballB)
beamBC = beam(space, ballB, ballC)

pin(space, beamDF, ballA, (300,0))
pin(space, beamBC, ballP, (40,0))

groove(space, beamDF, ballC)

ballB.velocity = (0, -500)   # move up
pts = animate(screen, space, ballP)
plotPoints(pts, title)