
# logSpiral.py
# Andrew Davison, ad@coe.psu.ac.th, Feb. 2025
# https://en.wikipedia.org/wiki/Logarithmic_spiral
'''
The spiral takes almost half a rotation of the bar
to become visible since ballP takes a while to pick 
up speed and leave the origin
'''

import os
os.environ['PYGAME_HIDE_SUPPORT_PROMPT'] = "hide"
from pymunk.vec2d import Vec2d
from linkUtils import *

screen = scrInit("Logarithmic Spiral", width=800, height=800)
scrWidth, scrHeight = screen.get_size()
space = pymunk.Space()

coord0 = Vec2d(scrWidth/2, scrHeight/2)
coordB = coord0 + Vec2d(scrWidth/2,0)

pt0 = staticBall(space, "", coord0)
ballB = ball(space, "B", coordB)  # to the right
ballP = ball(space, "P", coord0, color=RED) 

beam0B = beam(space, pt0, ballB)
groove(space, beam0B, ballP)

ballB.velocity = (0,-100)  # move up 
animate(screen, space, ballP)
