
# parallelogramBraced.py
# Andrew Davison, ad@coe.psu.ac.th, Feb. 2025
# "Geometric Folding Algorithms", sec 3.2.2.1, p.37

import math
import os
os.environ['PYGAME_HIDE_SUPPORT_PROMPT'] = "hide"
from pymunk.vec2d import Vec2d
from linkUtils import *


screen = scrInit("Braced Parallelogram", width=900)
scrWidth, scrHeight = screen.get_size()
space = pymunk.Space()
coord0 = Vec2d(scrWidth/2, scrHeight/2)

a = 100
coordA = coord0 + Vec2d(-2*a, 0)
coordB = coordA + Vec2d(4*a, 0)
coordC = coordA + Vec2d(0, -2*a)
coordD = coordB + Vec2d(0, -2*a)

# coordinates of the pins used for the braces
coordE = coordA + Vec2d(0, -a)  # horizontal
coordF = coordB + Vec2d(0, -a)
coordG = coordA + Vec2d(2*a, 0) # vertical
coordH = coordC + Vec2d(2*a, 0)


ptA = staticBall(space, "A", coordA)
ptB = staticBall(space, "B", coordB)  
ballC = ball(space, "C", coordC)
ballD = ball(space, "D", coordD, color=RED)  

ballE = ball(space, "E", coordE)
ballF = ball(space, "F", coordF)  
ballG = ball(space, "G", coordG)
ballH = ball(space, "H", coordH)  

beamAB = beam(space, ptA, ptB)
beamAC = beam(space, ptA, ballC)
beamCD = beam(space, ballC, ballD)
beamBD = beam(space, ptB, ballD)

pin(space, beamAC, ballE, (coordC-coordA)/2)
pin(space, beamBD, ballF, (coordD-coordB)/2)
pin(space, beamAB, ballG, (coordB-coordA)/2)
pin(space, beamCD, ballH, (coordD-coordC)/2)

# braces: comment out these two line to remove
beamEF = beam(space, ballE, ballF)  # horizontal
beamGH = beam(space, ballG, ballH)  # vertical

animate(screen, space, ballD)
